unit MDB_Interface;

(******************************************************************************
 *                                                                            *
 *   wh Mnzprfer Dietmar Trenner GmbH                                       *
 *                                                                            *
 *   Teltower Damm 276                                                        *
 *   D-14167 Berlin                                                           *
 *                                                                            *
 *   Accessing MDB devices under Windows and Linux                            *
 *                                                                            *
 *   Definitions of constants and structures                                  *
 *                                                                            *
 *   Version 1.60, 17.03.2003                                                 *
 *                                                                            *
 ******************************************************************************)

interface

uses MDB_Defines;

(******************************************************************************
 *                                                                            *
 *      Windows 98/ME/2000/XP                                                 *
 *                                                                            *
 ******************************************************************************)

 (******************************************************* common MDB functions *)

{$IFDEF MSWINDOWS}
const MDB_DLL	= 'WinMDB32.dll';

// open and close MDB
function OpenMDB ( comnr: Integer ): Integer; stdcall; external MDB_DLL;
function OpenMDB_str ( tty_name: PChar ): Integer; stdcall; external MDB_DLL;
function CloseMDB: Integer; stdcall; external MDB_DLL;

// reset all MDB devices
function ResetMDBDevices: Integer; stdcall; external MDB_DLL;

// set bits of the auxiliary port
function SetAuxPort ( stat, msk: BYTE ): Integer; stdcall; external MDB_DLL;

(*************************************************** coin validator fucntions *)

// open/close coin validator
function OpenEMP: Integer; stdcall; external MDB_DLL;
function CloseEMP: Integer; stdcall; external MDB_DLL;

// reset coin validator
function ResetEMP: Integer; stdcall; external MDB_DLL;

// get information about coin validator
function GetEMPInfo ( eip: EMPInfoPtr ): Integer; stdcall; external MDB_DLL;

// get current coin routing
function GetEMPCurrent ( ecp: EMPCurrentPtr ): Integer; stdcall; external MDB_DLL;

// set current coin routing
function SetEMPCurrent ( ecp: EMPCurrentPtr ): Integer; stdcall; external MDB_DLL;

// poll coin validator
function PollEMP: Integer; stdcall; external MDB_DLL;

// get last poll status
function GetLastEMPPoll ( epp: EMPPollStatusPtr ): Integer; stdcall; external MDB_DLL;

// get customer code
function GetEMPCustomer ( cdp: IntegerPtr ): Integer; stdcall; external MDB_DLL;

(***************************************************** change giver functions *)

// open/close change giver
function OpenCHG: Integer; stdcall; external MDB_DLL;
function CloseCHG: Integer; stdcall; external MDB_DLL;

// reset change giver
function ResetCHG: Integer; stdcall; external MDB_DLL;

// get information about change giver
function GetCHGInfo ( cip: CHGInfoPtr ): Integer; stdcall; external MDB_DLL;

// get tube status
function GetCHGTubeStat ( ctp: CHGTubeStatPtr ): Integer; stdcall; external MDB_DLL;

// dispense a number of coins
function DispenseCHGCoins ( dcp: CHGDispensePtr ): Integer; stdcall; external MDB_DLL;

// unlock coins
function SetCHGCurrent ( ccp: CHGCurrentPtr ): Integer; stdcall; external MDB_DLL;

// poll change giver
function PollCHG: Integer; stdcall; external MDB_DLL;

// get last poll status
function GetLastCHGPoll ( cpp: CHGPollStatusPtr ): Integer; stdcall; external MDB_DLL;

// not fully tested: write to the changer's display
function SetCHGDisplay ( attr, xpos, ypos: Integer; msg: PChar ): Integer; stdcall; external MDB_DLL;

(*************************************************** bill validator functions *)

// open/close bill validator
function OpenBLV: Integer; stdcall; external MDB_DLL;
function CloseBLV: Integer; stdcall; external MDB_DLL;

// reset
function ResetBLV: Integer; stdcall; external MDB_DLL;

// get information about bill validator
function GetBLVInfo ( bip: BLVInfoPtr ): Integer; stdcall; external MDB_DLL;

// get stacker status
function GetBLVStacker ( bsp: BLVStackerPtr ): Integer; stdcall; external MDB_DLL;

// unlock bills
function SetBLVCurrent ( bcp: BLVCurrentPtr ): Integer; stdcall; external MDB_DLL;

// get/set high security level
function GetBLVSecurity ( bsp: BLVSecurityPtr ): Integer; stdcall; external MDB_DLL;
function SetBLVSecurity ( bsp: BLVSecurityPtr ): Integer; stdcall; external MDB_DLL;

// escrow or stack bill
function ReturnBLVBill: Integer; stdcall; external MDB_DLL;
function StackBLVBill: Integer; stdcall; external MDB_DLL;

// poll bill validator
function PollBLV: Integer; stdcall; external MDB_DLL;

// get last poll status
function GetLastBLVPoll ( cpp: BLVPollStatusPtr ): Integer; stdcall; external MDB_DLL;

(****************************************************** card reader functions *)

// open/close card reader
function OpenCRD: Integer; stdcall; external MDB_DLL;
function OpenCRDEx ( batt, res0, res1: Integer ): Integer; stdcall; external MDB_DLL;
function CloseCRD: Integer; stdcall; external MDB_DLL;

// reset
function ResetCRD: Integer; stdcall; external MDB_DLL;

// get information about card reader
function GetCRDInfo ( cip: CRDInfoPtr ): Integer; stdcall; external MDB_DLL;

// initialize the card reader
function InitCRD: Integer; stdcall; external MDB_DLL;

// setup the card reader
function SetupCRD ( csp: CRDSetupPtr ): Integer; stdcall; external MDB_DLL;

// get reader state
function GetCRDState: Integer; stdcall; external MDB_DLL;

// get display data
function GetCRDDisplay ( cdp: CRDDisplayPtr ): Integer; stdcall; external MDB_DLL;

// get available credit
function GetCRDCredit: Double; stdcall; external MDB_DLL;

// get payment media info
function GetCRDMedia ( cmp: CRDMediaInfoPtr ): Integer; stdcall; external MDB_DLL;

// debit an amount
function DebitCRD ( prc: Double; dbtp: DoublePtr ): Integer; stdcall; external MDB_DLL;

// cancel activities
function CancelCRD: Integer; stdcall; external MDB_DLL;

// poll the cardreader
function PollCRD: Integer; stdcall; external MDB_DLL;

// inquire last poll status
function GetLastCRDPoll ( cpp: CRDPollStatusPtr ): Integer; stdcall; external MDB_DLL;

// Request vend
function VendRequestCRD ( prc: Double; dbtp: DoublePtr ): Integer; stdcall; external MDB_DLL;

// Vend success
function VendSuccessCRD: Integer; stdcall; external MDB_DLL;

// vend failure
function VendFailureCRD: Integer; stdcall; external MDB_DLL;

{$ENDIF}

(******************************************************************************
 *                                                                            *
 *      Linux                                                                 *
 *                                                                            *
 ******************************************************************************)

{$IFDEF LINUX}
const MDB_DLL	= 'libmdb.so';

// open and close MDB
function OpenMDB_str ( tty_name: PChar ): Integer; cdecl; external MDB_DLL;
function CloseMDB: Integer; cdecl; external MDB_DLL;

// reset all MDB devices
function ResetMDBDevices: Integer; cdecl; external MDB_DLL;

// set bits of the auxiliary port
function SetAuxPort ( stat, msk: BYTE ): Integer; cdecl; external MDB_DLL;

(*************************************************** coin validator fucntions *)

// open/close coin validator
function OpenEMP: Integer; cdecl; external MDB_DLL;
function CloseEMP: Integer; cdecl; external MDB_DLL;

// reset coin validator
function ResetEMP: Integer; cdecl; external MDB_DLL;

// get information about coin validator
function GetEMPInfo ( eip: EMPInfoPtr ): Integer; cdecl; external MDB_DLL;

// get current coin routing
function GetEMPCurrent ( ecp: EMPCurrentPtr ): Integer; cdecl; external MDB_DLL;

// set current coin routing
function SetEMPCurrent ( ecp: EMPCurrentPtr ): Integer; cdecl; external MDB_DLL;

// poll coin validator
function PollEMP: Integer; cdecl; external MDB_DLL;

// get last poll status
function GetLastEMPPoll ( epp: EMPPollStatusPtr ): Integer; cdecl; external MDB_DLL;

// get customer code
function GetEMPCustomer ( cdp: IntegerPtr ): Integer; cdecl; external MDB_DLL;

(***************************************************** change giver functions *)

// open/close change giver
function OpenCHG: Integer; cdecl; external MDB_DLL;
function CloseCHG: Integer; cdecl; external MDB_DLL;

// reset change giver
function ResetCHG: Integer; cdecl; external MDB_DLL;

// get information about change giver
function GetCHGInfo ( cip: CHGInfoPtr ): Integer; cdecl; external MDB_DLL;

// get tube status
function GetCHGTubeStat ( ctp: CHGTubeStatPtr ): Integer; cdecl; external MDB_DLL;

// dispense a number of coins
function DispenseCHGCoins ( dcp: CHGDispensePtr ): Integer; cdecl; external MDB_DLL;

// unlock coins
function SetCHGCurrent ( ccp: CHGCurrentPtr ): Integer; cdecl; external MDB_DLL;

// poll change giver
function PollCHG: Integer; cdecl; external MDB_DLL;

// get last poll status
function GetLastCHGPoll ( cpp: CHGPollStatusPtr ): Integer; cdecl; external MDB_DLL;

(*************************************************** bill validator functions *)

// open/close bill validator
function OpenBLV: Integer; cdecl; external MDB_DLL;
function CloseBLV: Integer; cdecl; external MDB_DLL;

// reset
function ResetBLV: Integer; cdecl; external MDB_DLL;

// get information about bill validator
function GetBLVInfo ( bip: BLVInfoPtr ): Integer; cdecl; external MDB_DLL;

// get stacker status
function GetBLVStacker ( bsp: BLVStackerPtr ): Integer; cdecl; external MDB_DLL;

// unlock bills
function SetBLVCurrent ( bcp: BLVCurrentPtr ): Integer; cdecl; external MDB_DLL;

// get/set high security level
function GetBLVSecurity ( bsp: BLVSecurityPtr ): Integer; cdecl; external MDB_DLL;
function SetBLVSecurity ( bsp: BLVSecurityPtr ): Integer; cdecl; external MDB_DLL;

// escrow or stack bill
function ReturnBLVBill: Integer; cdecl; external MDB_DLL;
function StackBLVBill: Integer; cdecl; external MDB_DLL;

// poll bill validator
function PollBLV: Integer; cdecl; external MDB_DLL;

// get last poll status
function GetLastBLVPoll ( cpp: BLVPollStatusPtr ): Integer; cdecl; external MDB_DLL;

{$ENDIF}

implementation

end.

