Attribute VB_Name = "WinMDB"
'/*******************************************************************************
' *                                                                             *
' *   wh Mnzprfer Berlin GmbH                                                 *
' *                                                                             *
' *   Teltower Damm 276                                                         *
' *   D-14167 Berlin                                                            *
' *                                                                             *
' *   Accessing MDB and ccTalk devices under Windows 98/ME/2000/XP              *
' *                                                                             *
' *   Expects "Option Base 0" which is the default setting.                     *
' *                                                                             *
' *   Please note:                                                              *
' *   The Option Base statement is not supported in VB.Net as the lower bound   *
' *   of all arrays must be zero!                                               *
' *                                                                             *
' *   Version 3.00, 17.11.2005                                                  *
' *                                                                             *
' *******************************************************************************/


(***************************************************************** open modes *)

Global Const OM_NOCOMIF = &H00010000				' don't check for COM interface
Global Const OM_NOCCTIF = &H00020000				' don't check for CCT interface

' Common MDB functions **********************************************************

Declare Function OpenMDB Lib "WinMDB32.dll" (com_nr As Long) As Long
Declare Function CloseMDB Lib "WinMDB32.dll" () As Long

' error codes MDB handling
Global Const MDB_OK = 0                             ' O.K.
Global Const MDB_BADCOMNO = -1                      ' invalid COM port
Global Const MDB_NOINIT = -2                        ' not initialised
Global Const MDB_OPENERROR = -3                     ' can't open COM
Global Const MDB_INITERROR = -4                     ' can't initialise COM
Global Const MDB_BADCSUM = -5                       ' checksum error
Global Const MDB_ANSTO = -6                         ' response timeout
Global Const MDB_CHARTO = -7                        ' character timeout
Global Const MDB_NOACK = -8                         ' no Acknowledge
Global Const MDB_NAKRCVD = -9                       ' NAK received
Global Const MDB_NOTRDY = -10                       ' Controller not ready
Global Const MDB_TOOLONG = -11                      ' block too long
Global Const MDB_SNDERROR = -12                     ' COM send error
Global Const MDB_RCVERROR = -13                     ' COM receive error
Global Const MDB_CTRLTOT = -14                      ' Controller timeout
Global Const MDB_WRONGADR = -15                     ' invalid MDB address
Global Const MDB_WRONGMC = -16                      ' wrong Controller
Global Const MDB_BADID = -20                        ' can't identify device
Global Const MDB_DLLERR = -21                       ' error loading DLL
Global Const MDB_PROCERR = -22                      ' error getting procedure address

' Coin validator ****************************************************************

Declare Function OpenEMP Lib "WinMDB32.dll" () As Long
Declare Function CloseEMP Lib "WinMDB32.dll" () As Long
Declare Function GetEMPInfo Lib "WinMDB32.dll" (ByRef EMP_info As EMPinfo) As Long
Declare Function GetEMPInfoEx Lib "WinMDB32.dll" (ByRef EMP_infoEx As EMPinfoEx) As Long
Declare Function GetEMPCurrent Lib "WinMDB32.dll" (ByRef EMP_current As EMPcurrent) As Long
Declare Function SetEMPCurrent Lib "WinMDB32.dll" (ByRef EMP_current As EMPcurrent) As Long
Declare Function PollEMP Lib "WinMDB32.dll" () As Long
Declare Function GetLastEMPPoll Lib "WinMDB32.dll" (ByRef EMP_status As EMPstatus) As Long

' error codes coin validator
Global Const EMP_OK = 0
Global Const EMP_NOINIT = -101                      ' coin validator not open
Global Const EMP_OPENED = -102                      ' coin validator already opened
Global Const EMP_ANSERROR = -103                    ' coin validator didn't respond
Global Const EMP_NULLPTR = -104                     ' call with invalid pointer
Global Const EMP_BADLEN = -105                      ' coin validator wrong block length in response

'bitmasks for poll response
Global Const EMPP_COIN = &H1                        ' coin data transmitted
Global Const EMPP_RESET = &H2                       ' was reset
Global Const EMPP_RETURN = &H4                      ' return lever pushed
Global Const EMPP_REJECT = &H8                      ' coin rejected
Global Const EMPP_NOINIT = &H10                     ' not initialised
Global Const EMPP_NOANSWER = &H20                   ' no response
Global Const EMPP_UNKNOWN = &H40                    ' unknown status
Global Const EMPP_TIMEOUT = &H80                    ' no-Response time exceeded

' about the coin validator
Type EMPinfo
        device(12)      As Byte                     ' device name
        model(12)       As Byte                     ' model
        version(1)      As Byte                     ' software version
        features(3)     As Byte                     ' feature flags
        country         As Long                     ' country code
        decimals        As Long                     ' decimals
        coin_value(15)  As Single                   ' coin values
        tubes           As Long                     ' number of slots
        cashbox         As Long                     ' number of the cashbox
        tube(15)        As Long                     ' coin routing
End Type

' more about the coin validator
Type EMPinfoEx
        manufacturer(32)As Byte                     ' manufacturer
        device(12)      As Byte                     ' device name
        model(12)       As Byte                     ' model
        version(1)      As Byte                     ' software version
        features(3)     As Byte                     ' feature flags
        country         As Long                     ' country code
        decimals        As Long                     ' decimals
        coin_value(15)  As Single                   ' coin values
        coin_currency(15,3) As Byte					' currency ID
        tubes           As Long                     ' number of slots
        cashbox         As Long                     ' number of the cashbox
        tube(15)        As Long                     ' coin routing
End Type

' coin routing and locking
Type EMPcurrent
        cashbox         As Long                     ' cashbox
        nlock(15)       As Long                     ' unlock coin
        incbox(15)      As Long                     ' route coin to cashbox
        tubes(15)       As Long                     ' coin slot
End Type

' last poll status
Type EMPstatus
        status          As Long                     ' status, see bitmasks for poll response
        coin            As Long                     ' coin number
        slot            As Long                     ' coin slot
        reject          As Long                     ' rejection code
        extended        As Long                     ' extended information
        mdberr          As Long                     ' MDB error code, see above
End Type

Global EMP_info         As EMPinfo
Global EMP_current      As EMPcurrent
Global EMP_status       As EMPstatus

' Change giver ******************************************************************

Declare Function OpenCHG Lib "WinMDB32.dll" () As Long
Declare Function CloseCHG Lib "WinMDB32.dll" () As Long
Declare Function ResetCHG Lib "WinMDB32.dll" () As Long
Declare Function GetCHGInfo Lib "WinMDB32.dll" (ByRef CHG_Info As chginfo) As Long
Declare Function GetCHGTubeStat Lib "WinMDB32.dll" (ByRef CHG_TubeStat As CHGTubeStat) As Long
Declare Function DispenseCHGCoins Lib "WinMDB32.dll" (ByRef CHG_Dispense As CHGDispense) As Long
Declare Function DispenseCHGValue Lib "WinMDB32.dll" (ByRef DispValue As Double, Force As Long) As Long
Declare Function SetCHGCurrent Lib "WinMDB32.dll" (ByRef CHG_Current As CHGCurrent) As Long
Declare Function PollCHG Lib "WinMDB32.dll" () As Long
Declare Function GetLastCHGPoll Lib "WinMDB32.dll" (ByRef CHG_PollStatus As CHGPollStatus)

' error codes changer

Global Const CHG_OK = 0
Global Const CHG_NOINIT = -201                      ' changer not open
Global Const CHG_OPENED = -202                      ' changer already opened
Global Const CHG_ANSERROR = -203                    ' changer didn't respond
Global Const CHG_NULLPTR = -204                     ' call with invalid pointer
Global Const CHG_BADLEN = -205                      ' wrong block length in response
Global Const CHG_BADLEVEL = -206                    ' insufficient featurer level
Global Const CHG_DISPERR = -207                     ' payout error
Global Const CHG_INTERNAL = -208                   ' internal error

' bit masks for poll results
Global Const CHGP_DISPENSE = &H1                    ' coin dispensed
Global Const CHGP_DEPOSIT = &H2                     ' coin accepted
Global Const CHGP_RETURN = &H4                      ' return lever pushed
Global Const CHGP_POTBUSY = &H8                     ' payout busy
Global Const CHGP_NOCREDIT = &H10                   ' error accepting coin
Global Const CHGP_SENSFAIL = &H20                   ' defective tube sensor
Global Const CHGP_DBLARRVL = &H40                   ' followup coin
Global Const CHGP_UNPLGGD = &H80                    ' coin validator removed
Global Const CHGP_TUBEJAM = &H100                   ' tube jam
Global Const CHGP_ROMCSUM = &H200                   ' internal checksum error
Global Const CHGP_ROUTERR = &H400                   ' internal routing error
Global Const CHGP_BUSY = &H800                      ' busy
Global Const CHGP_RESET = &H1000                    ' was reset
Global Const CHGP_COINJAM = &H2000                  ' coin jam
Global Const CHGP_SLUG = &H4000                     ' slug
Global Const CHGP_REJECT = &H8000                   ' rejected
Global Const CHGP_TIMEOUT = &H10000                 ' No-Response time exceeded
Global Const CHGP_UNKNOWN = &H80000                 ' unknown status

Global Const CHGP_MDBERR = &H10000000               ' MDB error

' about the change giver
Type chginfo
        device(12)      As Byte                     ' device name
        model(12)       As Byte                     ' model
        version(1)      As Byte                     ' software version
        features(3)     As Byte                     ' feature flags
        country         As Long                     ' country code
        decimals        As Long                     ' decimals
        least_coin      As Single                   ' least dispensable coin
        coin_value(15)  As Single                   ' coin values
        tube_coin(15)   As Long                     ' flags for tube coins
End Type

' coin locking
Type CHGCurrent
        nlock(15)       As Long                     ' unlock
End Type

' tube status
Type CHGTubeStat
        coinctr(15)     As Long                     ' number of coins
        tube_full(15)   As Long                     ' tube full
        tube_err(15)    As Long                     ' defective tube
End Type

' dispensed coins
Type CHGDispense
        dispnsd(15)     As Long                     ' number of coins
End Type

' last poll status
Type CHGPollStatus
        status          As Long                     ' status, see bitmasks for poll response
        coin            As Long                     ' coin number
        coinctr         As Long                     ' counter for tube coins
        mdberr          As Long                     ' MDB error code, see above
End Type


' Bill validator ****************************************************************

Declare Function OpenBLV Lib "WinMDB32.dll" () As Long
Declare Function CloseBLV Lib "WinMDB32.dll" () As Long
Declare Function ResetBLV Lib "WinMDB32.dll" () As Long
Declare Function GetBLVInfo Lib "WinMDB32.dll" (ByRef BLV_Info As BLVInfo) As Long
Declare Function GetBLVStacker Lib "WinMDB32.dll" (ByRef BLV_Stacker As BLVStacker) As Long
Declare Function SetBLVCurrent Lib "WinMDB32.dll" (ByRef BLV_Current As BLVCurrent) As Long
Declare Function ReturnBLVBill Lib "WinMDB32.dll" () As Long
Declare Function StackBLVBill Lib "WinMDB32.dll" () As Long
Declare Function PollBLV Lib "WinMDB32.dll" () As Long
Declare Function GetLastBLVPoll Lib "WinMDB32.dll" (ByRef BLV_PollStatus As BLVPollStatus) As Long     '(bry Benutzdefinierter Typ ist nicht definiert )

' error codes bill validator
Global Const BLV_OK = 0
Global Const BLV_NOINIT = -301                      ' bill validator not open
Global Const BLV_OPENED = -302                      ' bill validator already opened
Global Const BLV_ANSERROR = -303                    ' bill validator didn't respond
Global Const BLV_NULLPTR = -304                     ' call with invalid pointer
Global Const BLV_BADLEN = -305                      ' wrong block length in response
Global Const BLV_BADLEVEL = -306                    ' insufficient feature level
Global Const BLV_ESCRERR = -307                     ' escrow error
Global Const BLV_STACKERR = -308                    ' stack error

' bill position
Global Const NO_BILL = 100                          ' no bill
Global Const BILL_STACKED = 0                       ' bill stacked
Global Const ESCROW_POSITION = 1                    ' bill in escrow position
Global Const BILL_RETURNED = 2                      ' bill retrurned
Global Const NOT_USED = 3                           ' not used
Global Const BILL_REJECTED = 4                      ' disabled bill rejected

' poll status
Global Const BLVP_BILL = &H1                        ' bill accepted
Global Const BLVP_MOTFAIL = &H2                     ' motor error
Global Const BLVP_SENSFAIL = &H4                    ' sensor error
Global Const BLVP_BUSY = &H8                        ' busy
Global Const BLVP_ROMCSUM = &H10000000              ' ROM checksum error
Global Const BLVP_JAMMED = &H20                     ' bill jam
Global Const BLVP_RESET = &H40                      ' was reset
Global Const BLVP_REMOVED = &H80                    ' bill manually removed
Global Const BLVP_NOCASHBOX = &H100                 ' cash box removed
Global Const BLVP_DISABLED = &H200                  ' disabled
Global Const BLVP_BADESCROW = &H400                 ' invalid escrow request
Global Const BLVP_REJECTED = &H800                  ' bill returned
Global Const BLVP_TIMEOUT = &H1000                  ' no-Response Zeit exceeded
Global Const BLVP_UNKNOWN = &H80000                 ' Who knows?

Global Const BLVP_MDBERR = &H10000000               ' MDB error

' about the bill validator
Type BLVInfo
        device(12)      As Byte                     ' device name
        model(12)       As Byte                     ' model
        version(1)      As Byte                     ' software version
        features(3)     As Byte                     ' feature flags
        country         As Long                     ' country code
        decimals        As Long                     ' decimals
        escrowcap       As Long                     ' escrow capability
        stackercap      As Long                     ' stacke capacity
        bill_value(15)  As Single                   ' bill values
End Type

' bill locking
Type BLVCurrent
       nlock(15)        As Long                     ' unlock
       escrenab(15)     As Long                     ' escrow enabled
End Type

' stacker status
Type BLVStacker
        bills           As Long                     ' number of bills
        full            As Long                     ' full status
End Type

' last poll status
Type BLVPollStatus
        status          As Long                     ' status, see bitmasks for poll response
        bill            As Long                     ' bill number
        billpos         As Long                     ' bill position, see above
        mdberr          As Long                     ' MDB error code, see above
End Type


