using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using whSelectorCommunication;

namespace USBCoinSelector
{
    public enum SelectorStates
    {
        Closed,
        Open,
        Polling,
        Failure,
    }

    public partial class SelectorForm : Form
    {
        public SelectorForm(whSelectorComm formacc, USBSelConfig cconf, FrmMain mainfrm, int no)
        {
            InitializeComponent();
            CurrSel = formacc;
            CurrConfig = cconf;
            SelNo = no;
            mfrm = mainfrm;
            currstate = SelectorStates.Closed;
            #region Get controls into arrays
            tbValues = new TextBox[16];
            tbValues[00] = tbValue00;
            tbValues[01] = tbValue01;
            tbValues[02] = tbValue02;
            tbValues[03] = tbValue03;
            tbValues[04] = tbValue04;
            tbValues[05] = tbValue05;
            tbValues[06] = tbValue06;
            tbValues[07] = tbValue07;
            tbValues[08] = tbValue08;
            tbValues[09] = tbValue09;
            tbValues[10] = tbValue10;
            tbValues[11] = tbValue11;
            tbValues[12] = tbValue12;
            tbValues[13] = tbValue13;
            tbValues[14] = tbValue14;
            tbValues[15] = tbValue15;
            tbCurrencies = new TextBox[16];
            tbCurrencies[00] = tbCurrency00;
            tbCurrencies[01] = tbCurrency01;
            tbCurrencies[02] = tbCurrency02;
            tbCurrencies[03] = tbCurrency03;
            tbCurrencies[04] = tbCurrency04;
            tbCurrencies[05] = tbCurrency05;
            tbCurrencies[06] = tbCurrency06;
            tbCurrencies[07] = tbCurrency07;
            tbCurrencies[08] = tbCurrency08;
            tbCurrencies[09] = tbCurrency09;
            tbCurrencies[10] = tbCurrency10;
            tbCurrencies[11] = tbCurrency11;
            tbCurrencies[12] = tbCurrency12;
            tbCurrencies[13] = tbCurrency13;
            tbCurrencies[14] = tbCurrency14;
            tbCurrencies[15] = tbCurrency15;
            tbPaths = new TextBox[16];
            tbPaths[00] = tbPath00;
            tbPaths[01] = tbPath01;
            tbPaths[02] = tbPath02;
            tbPaths[03] = tbPath03;
            tbPaths[04] = tbPath04;
            tbPaths[05] = tbPath05;
            tbPaths[06] = tbPath06;
            tbPaths[07] = tbPath07;
            tbPaths[08] = tbPath08;
            tbPaths[09] = tbPath09;
            tbPaths[10] = tbPath10;
            tbPaths[11] = tbPath11;
            tbPaths[12] = tbPath12;
            tbPaths[13] = tbPath13;
            tbPaths[14] = tbPath14;
            tbPaths[15] = tbPath15;
            cbOverrides = new CheckBox[16];
            cbOverrides[00] = cbOverride00;
            cbOverrides[01] = cbOverride01;
            cbOverrides[02] = cbOverride02;
            cbOverrides[03] = cbOverride03;
            cbOverrides[04] = cbOverride04;
            cbOverrides[05] = cbOverride05;
            cbOverrides[06] = cbOverride06;
            cbOverrides[07] = cbOverride07;
            cbOverrides[08] = cbOverride08;
            cbOverrides[09] = cbOverride09;
            cbOverrides[10] = cbOverride10;
            cbOverrides[11] = cbOverride11;
            cbOverrides[12] = cbOverride12;
            cbOverrides[13] = cbOverride13;
            cbOverrides[14] = cbOverride14;
            cbOverrides[15] = cbOverride15;
            cbInhibits = new CheckBox[16];
            cbInhibits[00] = cbInhibit00;
            cbInhibits[01] = cbInhibit01;
            cbInhibits[02] = cbInhibit02;
            cbInhibits[03] = cbInhibit03;
            cbInhibits[04] = cbInhibit04;
            cbInhibits[05] = cbInhibit05;
            cbInhibits[06] = cbInhibit06;
            cbInhibits[07] = cbInhibit07;
            cbInhibits[08] = cbInhibit08;
            cbInhibits[09] = cbInhibit09;
            cbInhibits[10] = cbInhibit10;
            cbInhibits[11] = cbInhibit11;
            cbInhibits[12] = cbInhibit12;
            cbInhibits[13] = cbInhibit13;
            cbInhibits[14] = cbInhibit14;
            cbInhibits[15] = cbInhibit15;
            #endregion
        }

        public SelectorStates Status
        {
            get { return currstate; }
        }
        public bool WasVisible
        {
            get { return vbi; }
            set { vbi = value; }
        }

        // Private variables
        private FrmMain mfrm;
        private whSelectorComm CurrSel;
        private USBSelConfig CurrConfig;
        private int SelNo;
        private long pollcnt = 0;
        private bool accvalid = false, vbi;
        private SelectorStates currstate;
        private TextBox[] tbValues, tbCurrencies, tbPaths;
        private CheckBox[] cbOverrides, cbInhibits;
        // Selector Coins
        private whSelCoinValue[] SelCoinValues = new whSelCoinValue[16];
        private whSelCoinStatus[] SelCoinStates = new whSelCoinStatus[16];
        private int[] CoinCount = new int[16];
        
        // Private Methods
        private void SetStatus(SelectorStates newst)
        {
            SelectorStates oldst;
            oldst = currstate;
            currstate = newst;
            if (currstate != oldst) mfrm.ShowDevicesStates();
        }
        private void ShowSelStatus()
        {
            if (CurrSel.IsOpen)
            {
                sbStatus.Text = "Open";
                btnOpenClose.Text = "Close Selector";
            }
            else
            {
                sbStatus.Text = "Closed";
                btnOpenClose.Text = "Open Selector";
            }
        }
        private void ShowCommStatus()
        {
            sbLastError.Text = CurrSel.LastError.ToString();
        }
        private void ShowCreditList()
        {
            int i;
            lvCredits.Items.Clear();
            for (i = 0; i < 16; i++)
            {
                if (SelCoinValues[i].Value > 0.0001)
                {
                    string[] newItems = new string[] 
                    {
                        "",
                        string.Format("{0:d}", i + 1),
                        SelCoinValues[i].ID,
                        string.Format("{0:f2}", SelCoinValues[i].Value),
                        string.Format("{0:d}", CoinCount[i]),
                        string.Format("{0:f2}", SelCoinValues[i].Value * CoinCount[i]),
                    };
                    ListViewItem lvi = new ListViewItem(newItems);
                    lvCredits.Items.Add(lvi);
                }
                else
                {
                    string[] newItems = new string[] 
                    {
                        "",
                        string.Format("{0:d}", i + 1),
                        "",
                        "",
                        "",
                        "",
                    };
                    ListViewItem lvi = new ListViewItem(newItems);
                    lvCredits.Items.Add(lvi);
                }
            }
        }
        private void ShowMasterInhibit()
        {
            if (CurrSel.MasterInhibit)
                btnMasterInhibit.Text = "Reset Master Inhibit";
            else btnMasterInhibit.Text = "Set Master Inhibit";
        }
        private void UpdateCreditList()
        {
            int i;

            for (i = 0; i < 16; i++)
            {
                lvCredits.Items[i].SubItems[4].Text = string.Format("{0:d}", CoinCount[i]);
                lvCredits.Items[i].SubItems[5].Text = string.Format("{0:f2}", SelCoinValues[i].Value * CoinCount[i]);
            }
        }
        private void ReadCoinStates()
        {
            int i;
            for (i = 0; i < 16; i++)
            {
                SelCoinStates[i].Override = cbOverrides[i].Checked;
                SelCoinStates[i].Inhibit = cbInhibits[i].Checked;
                SelCoinStates[i].SorterPath = Convert.ToByte(tbPaths[i].Text);
            }
        }
        private void OpenClose()
        {
            if (CurrSel.IsOpen)
            {
                StopPoll();
                CurrSel.CloseComm();
                ClearDisplay();
                if (CurrSel.LastError == whSelErrors.Ok)
                    SetStatus(SelectorStates.Closed);
                else SetStatus(SelectorStates.Failure);
            }
            else
            {
                CurrSel.OpenComm();
                if (CurrSel.LastError == whSelErrors.Ok)
                    SetStatus(SelectorStates.Open);
                else SetStatus(SelectorStates.Failure);
            }
        }
        private void StopPoll()
        {
            tmrPoll.Enabled = false;
            btnPoll.Text = "Start Poll";
            sbPollAct.BackColor = SystemColors.Control;
            pollcnt = 0;
            if (CurrSel.LastError == whSelErrors.Ok)
                SetStatus(SelectorStates.Open);
            else SetStatus(SelectorStates.Failure);
        }
        private void StartPoll()
        {
            tmrPoll.Enabled = true;
            btnPoll.Text = "Stop Poll";
            pollcnt = 0;
        }
        private void ClearDisplay()
        {
            int i;

            tbManufacturer.Text = "";
            tbProductCode.Text = "";
            tbVersion.Text = "";
            tbSerial.Text = "";
            tbCustomerID.Text = "";
            sbLastError.Text = "";
            sbLastPoll.Text = "";
            lvCredits.Items.Clear();
            for (i = 0; i < 16; i++)
            {
                tbValues[i].Text = "";
                tbCurrencies[i].Text = "";
                tbPaths[i].Text = "0";
                cbOverrides[i].Checked = false;
                cbInhibits[i].Checked = false;
                string[] newItems = new string[] 
                {
                    "",
                    string.Format("{0:d}", i + 1),
                    "",
                    "",
                    "",
                    "",
                };
                ListViewItem lvi = new ListViewItem(newItems);
                lvCredits.Items.Add(lvi);
            }
            cbOvrAll0.Checked = false;
            cbOvrAll1.Checked = false;
            cbInhAll0.Checked = false;
            cbInhAll1.Checked = false;
            accvalid = false;
            Update();
        }
        private void ReadSelector()
        {
            int i, j;
            bool fnd;

            ClearDisplay();
            // Read selector data
            tbManufacturer.Text = CurrSel.Manufacturer;
            tbProductCode.Text = CurrSel.ProductCode;
            tbVersion.Text = CurrSel.SoftwareRevision;
            tbSerial.Text = string.Format("{0:d8}", CurrSel.SerialNumber);
            tbCustomerID.Text = string.Format("{0:d8}", CurrSel.CustomerID);
            CurrSel.GetCoinValues(ref SelCoinValues);
            CurrSel.GetCoinStates(ref SelCoinStates);
            // Display coins
            for (i = 0; i < 16; i++)
            {
                if (SelCoinValues[i].Value > 0.0001)
                {
                    tbValues[i].Text = string.Format("{0:f2}", SelCoinValues[i].Value);
                    tbCurrencies[i].Text = SelCoinValues[i].ID;
                }
                else
                {
                    tbValues[i].Text = "";
                    tbCurrencies[i].Text = "";
                }
                cbOverrides[i].Checked = SelCoinStates[i].Override;
                cbInhibits[i].Checked = SelCoinStates[i].Inhibit;
                tbPaths[i].Text = SelCoinStates[i].SorterPath.ToString();
            }
            ShowCommStatus();
            // Build credit list;
            for (i = 0; i < 16; i++)
            {
                if (SelCoinValues[i].Value > 0.0001)
                {
                    // Add to global credit list
                    fnd = false;
                    for (j = 0; j < mfrm.SelCreditCount; j++)
                    {
                        if (mfrm.GlobalCredits[j].ID == SelCoinValues[i].ID)
                        {
                            fnd = true;
                            break;
                        }
                    }
                    if (!fnd)
                    {
                        mfrm.SelCreditCount++;
                        mfrm.GlobalCredits[mfrm.SelCreditCount - 1].ID = SelCoinValues[i].ID;
                        mfrm.GlobalCredits[mfrm.SelCreditCount - 1].Total = 0;
                    }
                }
            }
            accvalid = CurrSel.LastError == whSelErrors.Ok;
            ShowMasterInhibit();
            ShowCreditList();
            mfrm.ShowCredits();
        }
        private void EnableButtons(bool status)
        {
            btnQuit.Enabled = status;
            btnOpenClose.Enabled = status;
            btnRead.Enabled = status && CurrSel.IsOpen && !tmrPoll.Enabled;
            btnPoll.Enabled = status && CurrSel.IsOpen;
            btnMasterInhibit.Enabled = status && CurrSel.IsOpen && !tmrPoll.Enabled;
            btnInhibit.Enabled = status && CurrSel.IsOpen && !tmrPoll.Enabled;
            btnOverride.Enabled = status && CurrSel.IsOpen && !tmrPoll.Enabled;
            btnPaths.Enabled = status && CurrSel.IsOpen && !tmrPoll.Enabled;
            if (status) Cursor.Current = Cursors.Arrow;
            else Cursor.Current = Cursors.WaitCursor;
        }

        // Events
        private void SelectorForm_Load(object sender, EventArgs e)
        {
            CurrConfig.LoadWinPos(this, "Selector" + string.Format("{0:d2}", SelNo), false);
            Text = "Selector " + string.Format("{0:d}", SelNo);
            nudPollingRate.Value = tmrPoll.Interval;
            EnableButtons(true);
            ShowSelStatus();
            ClearDisplay();
        }
        private void SelectorForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            if (btnQuit.Enabled)
            {
                CurrConfig.SaveWinPos(this, "Selector" + string.Format("{0:d2}", SelNo));
                Visible = false; ;
            }
        }
        private void SelectorForm_VisibleChanged(object sender, EventArgs e)
        {
            /*
            if (Visible)
            {
                Text = "Selector " + string.Format("{0:d}", SelNo);
                nudPollingRate.Value = tmrPoll.Interval;
                EnableButtons(true);
                ShowSelStatus();
                ClearDisplay();
            }
            else
            {
                StopPoll();
                if (CurrSel.IsOpen) CurrSel.CloseComm();
                ShowSelStatus();
                ShowCommStatus();
                ClearDisplay();
                EnableButtons(true);
            }
            */
        }

        private void btnQuit_Click(object sender, EventArgs e)
        {
            Close();
        }
        private void btnOpenClose_Click(object sender, EventArgs e)
        {
            EnableButtons(false);
            OpenClose();
            ShowSelStatus();
            ShowCommStatus();
            EnableButtons(true);
        }
        private void btnRead_Click(object sender, EventArgs e)
        {
            EnableButtons(false);
            ReadSelector();
            ShowCommStatus();
            EnableButtons(true);
        }
        private void btnMasterInhibit_Click(object sender, EventArgs e)
        {
            CurrSel.MasterInhibit = !CurrSel.MasterInhibit;
            ShowMasterInhibit();
        }
        private void btnInhibit_Click(object sender, EventArgs e)
        {
            EnableButtons(false);
            ReadCoinStates();
            CurrSel.SetCoinInhibit(SelCoinStates);
            EnableButtons(true);
        }
        private void btnOverride_Click(object sender, EventArgs e)
        {
            EnableButtons(false);
            ReadCoinStates();
            CurrSel.SetCoinOverride(SelCoinStates);
            EnableButtons(true);
        }
        private void btnPaths_Click(object sender, EventArgs e)
        {
            EnableButtons(false);
            ReadCoinStates();
            CurrSel.SetCoinSorterPaths(SelCoinStates);
            EnableButtons(true);
        }
        private void btnPoll_Click(object sender, EventArgs e)
        {
            EnableButtons(false);
            if (tmrPoll.Enabled) StopPoll(); else StartPoll();
            EnableButtons(true);
        }
        private void btnClearCredits_Click(object sender, EventArgs e)
        {
            int i;

            for (i = 0; i < 16; i++) CoinCount[i] = 0;
            UpdateCreditList();
        }

        private void cbOvrAll0_CheckedChanged(object sender, EventArgs e)
        {
            int i;

            for (i = 0; i < 16; i++)
                cbOverrides[i].Checked = ((CheckBox)sender).Checked;
        }
        private void cbInhAll1_CheckedChanged(object sender, EventArgs e)
        {
            int i;

            for (i = 0; i < 16; i++)
                cbInhibits[i].Checked = ((CheckBox)sender).Checked;
        }
        private void nudPollingRate_ValueChanged(object sender, EventArgs e)
        {
            tmrPoll.Interval = (int)nudPollingRate.Value;
        }

        private void tmrPoll_Tick(object sender, EventArgs e)
        {
            int i, j, cidx, EvtCnt;
            whSelPollResponse[] PollResps = new whSelPollResponse[whSelectorComm.MaxPollEvents];

            tmrPoll.Enabled = false;
            pollcnt++;

            CurrSel.PollSelector(ref PollResps, out EvtCnt);
            // Show polling activity
            if ((pollcnt % 2) == 0)
            {
                if (CurrSel.LastError == whSelErrors.Ok)
                    sbPollAct.BackColor = Color.Green;
                else sbPollAct.BackColor = Color.Red;
            }
            else
            {
                sbPollAct.BackColor = SystemColors.Control;
            }

            // Process poll response(s)
            if (EvtCnt > 0)
            {
                for (i = 0; i < EvtCnt; i++)
                {
                    // Show last poll
                    if (PollResps[i].Status == whSelPollEvent.Coin)
                    {
                        cidx = PollResps[i].CoinIndex;
                        sbLastPoll.Text = string.Format("{0:f2}", SelCoinValues[cidx].Value) + " " + SelCoinValues[cidx].ID;
                        // Show counts
                        CoinCount[cidx]++;
                        UpdateCreditList();
                        for (j = 0; j < mfrm.SelCreditCount; j++)
                        {
                            if (mfrm.GlobalCredits[j].ID == SelCoinValues[cidx].ID)
                            {
                                mfrm.GlobalCredits[j].Total += SelCoinValues[cidx].Value;
                                mfrm.ShowCredits();
                            }
                        }
                    }
                    else
                    {
                        sbLastPoll.Text = PollResps[i].Status.ToString();
                    }
                }
            }
            if ((PollResps.Length > 0) || (CurrSel.LastError != whSelErrors.Ok))
            {
                ShowCommStatus();
                if (CurrSel.LastError == whSelErrors.Ok)
                    SetStatus(SelectorStates.Polling);
                else SetStatus(SelectorStates.Failure);
            }
            tmrPoll.Enabled = true;
        }
    }
}